/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.annotation.valueprovider;

import org.fortiss.af3.exploration.moea.model.annotation.AnnotationPackage;
import org.fortiss.af3.exploration.moea.model.annotation.InterferenceLatency;
import org.fortiss.tooling.base.annotation.valueprovider.EStructuralFeatureValueProviderBase;
import org.fortiss.tooling.base.annotation.valueprovider.IAnnotationValueProvider;

/**
 * {@link IAnnotationValueProvider} for the {@link InterferenceLatency} annotation.
 * 
 * @author diewald
 */
public class InterferenceLatencyValueProvider
		extends EStructuralFeatureValueProviderBase<InterferenceLatency> {

	/** Constructor. */
	public InterferenceLatencyValueProvider() {
		super(AnnotationPackage.Literals.INTERFERENCE_LATENCY,
				AnnotationPackage.Literals.INTERFERENCE_LATENCY__LATENCY);
	}

	/** {@inheritDoc} */
	@Override
	public String getAnnotationName(InterferenceLatency specification) {
		return "Interference Latency";
	}
}
