/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse;

import java.lang.annotation.Annotation;
import java.util.Collection;
import java.util.Map;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.EncodingProviderGenerator;
import org.fortiss.af3.exploration.alg.module.InputModule;
import org.fortiss.af3.exploration.dseml.model.expression.SuperSet;

import com.google.inject.Injector;
import com.google.inject.Singleton;
import com.google.inject.TypeLiteral;

/**
 * Generator for {@link SuperSet} providers. It is served as a singleton from the guice
 * {@link Injector}.
 * These {@link SuperSet}s are used for the construction of the {@link InputModule}s.
 * 
 * @author diewald
 */
@Singleton
public class SuperSetProviderGenerator extends EncodingProviderGenerator<SuperSet<?>> {

	/** Constructor. */
	public SuperSetProviderGenerator(
			Collection<TypeLiteral<? extends SuperSet<?>>> encodingTypesToProvide,
			Map<TypeLiteral<? extends SuperSet<?>>, Class<? extends Annotation>> providerAnnotations) {
		super(encodingTypesToProvide, providerAnnotations);
	}
}
