/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.create.GuiceCreator;
import org.fortiss.af3.exploration.alg.module.CreatorModule;
import org.fortiss.af3.exploration.alg.module.DecoderModule;
import org.fortiss.af3.exploration.alg.module.OperatorModule;
import org.fortiss.af3.exploration.alg.service.module.IExplorationEncoding;
import org.opt4j.optimizers.ea.Mating;

/**
 * This {@link Exception} is thrown by {@link CreatorModule}s, {@link DecoderModule}s, or
 * {@link OperatorModule}s if they detect an infeasibility in the {@link IExplorationEncoding} they
 * process. This exception must be handled in the {@link GuiceCreator}, {@link GuiceCreator}, and
 * {@link Mating}, respectively.
 * 
 * @author diewald
 */
public class InfeasibleEncodingException extends RuntimeException {
	// Marker interface.
}
