/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.genotype;

import java.lang.annotation.Annotation;
import java.util.Collection;
import java.util.Map;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.EncodingProviderGenerator;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.decode.Genotyped;
import org.opt4j.core.Genotype;

import com.google.inject.Singleton;
import com.google.inject.TypeLiteral;

/**
 * Generator for {@link Genotype} providers. In addition to the {@link EncodingProviderGenerator}, a
 * {@link Genotyped} annoation is added to the Provides method.
 * 
 * @author diewald
 */
@Singleton
public class GenotypeProviderGenerator extends EncodingProviderGenerator<Genotype> {

	/**
	 * Constructor. It shall be used where the Guice exploration context is not available, or when a
	 * Guice-Instance-Binding is constructed.
	 */
	public GenotypeProviderGenerator(
			Collection<TypeLiteral<? extends Genotype>> encodingTypesToProvide,
			Map<TypeLiteral<? extends Genotype>, Class<? extends Annotation>> providerAnnotations) {
		super(encodingTypesToProvide, providerAnnotations);
	}
}
