/*-------------------------------------------------------------------------+
| Copyright 2014 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.sysmodel.arch;

/**
 * Adapter between requests (=tasks, messages, ...) of the system meta-model used in the modeling
 * tool, and the DSE.
 * 
 * @author barner
 */
public interface IRequestAdapter extends IModelElementAdapter {
	/**
	 * Returns the minimum number of replications allowed for this
	 * {@link ITaskAdapter}.
	 */
	default int getMinReplication() {
		return 1;
	}

	/**
	 * Returns the maximum number of replications allowed for this
	 * {@link ITaskAdapter}.
	 */
	default int getMaxReplication() {
		return 1;
	}
}
