/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.feature.taskmapping.problem;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.decode.Decodes;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.phenotype.Phenotype;
import org.fortiss.af3.exploration.alg.feature.platform.PlatformCommunicationGraphEncoding;
import org.fortiss.af3.exploration.alg.module.DecoderModule;
import org.fortiss.af3.exploration.alg.module.InputArtifact;
import org.opt4j.core.Genotype;

import com.google.inject.Provides;

/**
 * Takes a {@link PlatformCommunicationGraphEncoding} genotype and provides it as its
 * {@link Phenotype} representation.
 * 
 * @author diewald
 */
public class PlatformCommunicationGraphIdentityDecoder
		extends DecoderModule<PlatformCommunicationGraphEncoding> {

	/** See {@link PlatformCommunicationGraphIdentityDecoder}. */
	@Decodes
	@Provides
	public PlatformCommunicationGraphEncoding
			decode(@InputArtifact PlatformCommunicationGraphEncoding pcgEnc) {
		return pcgEnc;
	}

	/** {@inheritDoc} */
	@Override
	public PlatformCommunicationGraphEncoding decode(Genotype arg0) {
		// Required by the framework...
		return null;
	}
}
