/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.service.module;

import org.fortiss.af3.exploration.alg.module.IProvidingModule;
import org.fortiss.af3.exploration.dseml.model.expression.SuperSet;
import org.fortiss.tooling.base.model.element.IModelElement;

/**
 * Module for the transformation of DSE-internal encodings to {@link SuperSet}s that are understood
 * by the DSE backend.
 * 
 * @author diewald
 */
public interface IExplorationTransformationModule<T extends SuperSet<? extends IModelElement>>
		extends IProvidingModule<T> {
	// Aggregating interface for now.
}
